/*
  dualammo.c - Allows the Javelin Launcher to additionally use Eraser Missiles.

  Jason Hood, 24 & 25 August, 2009.

  This is a prototype application to demonstrate that it is possible for a
  single missile launcher (or any weapon, including mines and countermeasures)
  to use two (or more) ammo types.  It works by using the Toggle Weapon function
  to toggle the ammo, instead; hold down Shift to toggle the weapon.  It doesn't
  change the name in the list (to be expected, since the launcher doesn't
  change, but it should be possible), but the ammo count does change.  The
  current ammo will show up in the inventory, but if you change it while the
  weapons inventory is displayed, you'll need to select something else to
  refresh it.

  Build (VC 6):
	cl /nologo /W3 /GfX /Ox /MD /LD dualammo.c
*/


#define WIN32_LEAN_AND_MEAN
#include <windows.h>


__declspec(naked)
void DualAmmo( void )
{
  __asm push	16				// VK_SHIFT
  __asm call	dword ptr ds:[0x5c7280] 	// GetKeyState
  __asm test	ah, ah				// if Shift is pressed,
  __asm js	done				//  toggle weapon as usual
  __asm mov	eax, [esi+0x0C]
  __asm cmp	dword ptr [eax+0x08], 0xb447b94d // missile01_mark01?
  __asm jne	done
  __asm mov	ecx, [eax+0x98] 		// toggle missile01_mark01_ammo
  __asm xor	ecx, 0x01288080 		// and	  missile03_mark01_ammo
  __asm mov	[eax+0x98], ecx
  __asm push	ecx
  __asm call	dword ptr ds:[0x5c603c] 	// Archetype::GetEquipment
  __asm mov	[esi+0x4C], eax
  __asm pop	eax
  __asm xor	bl, 1				// restore current state

  done:
  __asm mov	eax, [esi]
  __asm push	ebx
  __asm mov	ecx, esi
  __asm push	0x535419
  __asm ret
}


__declspec(naked)
void Equip( void )
{
  __asm cmp	[esi-0x98+0x08], 0xb447b94d
  __asm jne	done
  __asm mov	ecx, [esp+0x14+4]
  __asm xor	ecx, 0x01288080
  __asm cmp	ecx, [esi]
  __asm jne	done
  __asm mov	dword ptr [esp], 0x482df5
  __asm ret
  done:
  __asm call	ds:[0x5c639c]			// Archetype::GetEquipmentByName
  __asm push	0x482dd4
  __asm ret
}


void Patch( void )
{
  #define ADDR_TOGGLE ((PBYTE)0x535414)
  #define ADDR_EQUIP  ((PBYTE)0x482dce)

  DWORD dummy;

  if (*ADDR_TOGGLE != 0x8B)
    return;

  VirtualProtect( ADDR_TOGGLE, 5, PAGE_EXECUTE_READWRITE, &dummy );
  ADDR_TOGGLE[0] = 0xe9;
  *(DWORD*)(ADDR_TOGGLE+1) = (PBYTE)DualAmmo - ADDR_TOGGLE - 5;

  VirtualProtect( ADDR_EQUIP, 5, PAGE_EXECUTE_READWRITE, &dummy );
  ADDR_EQUIP[0] = 0xe9;
  *(DWORD*)(ADDR_EQUIP+1) = (PBYTE)Equip - ADDR_EQUIP - 5;
}


BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
  if (fdwReason == DLL_PROCESS_ATTACH)
    Patch();

  return TRUE;
}
